unit UnitDataGraph;

interface

uses
   Windows, UnitFunc, UnitData, UnitGraph, UnitClipping ;

var
   ScrX, ScrY : integer ;  // ʃTCY(hbg)
   CenX, CenY : integer ;  // ʒ_(hbg)
   mm_dot : double ;       // mmhbgWϊW
   WndX1, WndY1 : double ; // ʍ_(mm)
   WndX2, WndY2 : double ; // ʉE_(mm)
   CData : TDataClass ;
   gp : TGraphClass ;

   procedure ZInit ;
   procedure Z2D(var ix,iy:integer;x,y:double);
   procedure DisplayLayCol1(lay,col:integer;var c,cc:integer);
   procedure DisplayLayCol2(lay,col,ltp,wid:integer;var c,cc,l,w:integer;var ww:double);
   procedure DisplayLineSub1(px1,py1,px2,py2:double);
   procedure DisplayLineSub2(l:integer;var i:integer;var d1:double;px1,py1,px2,py2:double);
   procedure DisplayTenMarker(lay,col,mc:integer;px,py,an,sc:double);
   procedure DisplayLine(lay,col,ltp,wid:integer;px1,py1,px2,py2:double);
   procedure DisplayLines(lay,col,ltp,wid,num:integer;vx,vy:array of double);
   procedure DisplayCircle(lay,col,ltp,wid:integer;px,py,pr:double;t:TMatrix);
   procedure DisplayArc(lay,col,ltp,wid,dir:integer;px,py,pr,sa,ea:double;t:TMatrix);
   procedure DisplayEllipse(lay,col,ltp,wid:integer;px,py,rx,ry,ra:double;t:TMatrix);
   procedure DisplayEllipseArc(lay,col,ltp,wid,dir:integer;px,py,rx,ry,ra,sa,ea:double;t:TMatrix);
   procedure DisplayText(lay,col,fon,bp,dir:integer;px,py,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayBezierSub(var xp,yp:double;t,x1,x2,x3,x4, y1,y2,y3,y4:double);
   procedure DisplayBezier(lay,col,ltp,wid,sp,num:integer;vx,vy:array of double);
   procedure DisplayBsplineSub(var xp,yp:double;t,x1,x2,x3,x4, y1,y2,y3,y4:double);
   procedure DisplayBspline(lay,col,ltp,wid,oc,sp,num:integer;vx,vy:array of double);
   procedure DisplaySplineSub1(var xp,yp:double;t,av,x0,x1,x2,x3, y0,y1,y2,y3:double);
   procedure DisplaySplineSub2(tn,nmax:integer;t:double;var tv,bn:array of double);
   procedure DisplaySplineSub3(tn,nmax,kai:integer;t:double;var tv,bn1,bn2:array of double);
   procedure DisplaySpline(lay,col,ltp,wid,stp,oc,sp,num:integer;av:double;vx,vy:array of double);
   procedure DisplayClothoidSub1(var x,y:double;p:double);
   procedure DisplayClothoidSub2(var x,y:double;A,l:double);
   procedure DisplayClothoid(lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double;t:TMatrix);
   procedure DisplaySymbolZukei(lay,cf,col:integer;nam:string;px,py,an,sc:double;t:TMatrix);
   procedure DisplayAllData ;

implementation

// ֘Aeϐ̏
//    in ScrX,ScrY ;
procedure ZInit ;
var
   mx,my : double ;
begin
   mx := (ScrX - 4)/CData.zp.x ;
   my := (ScrY - 4)/CData.zp.y ;
   if (mx < my) then
      mm_dot := mx
   else
      mm_dot := my ;

   CenX := ScrX div 2;    // ʒ
   CenY := ScrY div 2;

   // ʍ_
   WndX1 := CData.zp.x/2.0 + (0        - CenX)/mm_dot ;
   WndY1 := CData.zp.y/2.0 - ((ScrY-1) - CenY)/mm_dot ;
   // ʉE_
   WndX2 := CData.zp.x/2.0 + ((ScrX-1) - CenX)/mm_dot ;
   WndY2 := CData.zp.y/2.0 - (0        - CenY)/mm_dot ;
end;

// pmmWʃhbgW
procedure Z2D(var ix,iy:integer;x,y:double);
begin
{
   ix := Trunc(CenX + (x - CData.zp.x/2.0)*mm_dot) ;
   iy := Trunc(CenY - (y - CData.zp.y/2.0)*mm_dot) ;
}
   ix := Trunc( (x - WndX1)*mm_dot) ;
   iy := Trunc(-(y - WndY2)*mm_dot) ;

   // 킹獶㍇킹ɕύXĂ܂(test-018)
end;

// F̕\ETu
// (in)
//    lay: C(1-256)
//    col: F@(0,1-256) -1:w肵Ȃ
// (out)
//    c : F   (1-256)
//    cc: RGBF
procedure DisplayLayCol1(lay,col:integer;var c,cc:integer);
begin
   if (col >= 0) then begin
      c := col ;
      if (c = 0) then c := CData.zLay[lay-1].Color ;
      cc:= RGB(CData.zCol[c-1].Red,CData.zCol[c-1].Green,CData.zCol[c-1].Blue);
      gp.G_SetPen(cc);
   end;
end;

// FEE̕\ETu
// (in)
//    lay: C(1-256)
//    col: F@(0,1-256) -1:w肵Ȃ
//    ltp: (0,1-32)  -1:w肵Ȃ
//    wid: (0,1-16)  -1:w肵Ȃ
// (out)
//    c : F   (1-256)
//    cc: RGBF
//    l :  (1-32)
//    w :  (1-16)
//    ww:  [dot]
procedure DisplayLayCol2(lay,col,ltp,wid:integer;var c,cc,l,w:integer;var ww:double);
begin
   DisplayLayCol1(lay,col,c,cc);    // F
   if (ltp >= 0) then begin
      l := ltp ;
      if (l = 0) then l := CData.zLay[lay-1].Ltype ;
      // ۂ̐̕`́ADisplayLineSub2()ōs
   end;
   if (wid >= 0) then begin
      w := wid ;
      if (w = 0) then w := CData.zLay[lay-1].Width ;
      ww := CData.zWid[w-1].Width * mm_dot ;
      if (ww <   1.0) then ww :=   1.0 ;
      if (ww > 500.0) then ww := 500.0 ;
      gp.G_SetWidth(Round(ww));
   end;
end;

// ̕\ETuPF
//    px1,py1 : n_[mm]
//    px2,py2 : I_[mm]
//    FE͊Ɏw肵Ă鎖
procedure DisplayLineSub1(px1,py1,px2,py2:double);
var
   x1,y1,x2,y2 : integer ;
begin
   if (ClipLine(px1,py1,px2,py2, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   Z2D(x1,y1, px1,py1);
   Z2D(x2,y2, px2,py2);
   gp.G_Line(x1,y1,x2,y2);
end;

// ̕\ETuQFw
//    l : ԍ(1-)
//    i : JnZOgԍ(IXV)
//    d1: Jnsb`@@(IXV)
//    px1,py1 : n_[mm]
//    px2,py2 : I_[mm]
//    FE͊Ɏw肵Ă鎖
procedure DisplayLineSub2(l:integer;var i:integer;var d1:double;px1,py1,px2,py2:double);
var
   x1,y1,x2,y2 : integer ;
   a,sa,ca,d,p,wx1,wy1,wx2,wy2 : double ;
   fl : Boolean ;
begin
   if (ClipLine(px1,py1,px2,py2, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   a := Angle(px2-px1, py2-py1);
   d := Dist(px1,py1, px2,py2);
   ca:= Cos(a);
   sa:= Sin(a);
   wx1:= px1 ;
   wy1:= py1 ;
   fl := True ;
   while(fl) do begin
   	p := CData.zLtp[l-1].Pitch[i] - d1 ;
      if (p > d) then p := d ;
      wx2 := wx1 + p*ca ;
      wy2 := wy1 + p*sa ;
      if ((i mod 2) = 0) then begin
         Z2D(x1,y1, wx1,wy1);
         Z2D(x2,y2, wx2,wy2);
         gp.G_Line(x1,y1,x2,y2);
      end;
      wx1 := wx2 ;
      wy1 := wy2 ;
      d := d - p ;
      if (d <= LIMIT8) then begin
      	fl := False ;
      	d1 := d1 + p ;
      end
      else begin
     		d1 := 0.0 ;
         Inc(i);
         if (i >= CData.zLtp[l-1].Segment) then i:=0;
      end;
   end;
end;

// _}[J̕\
//    an : ]p[rad]
procedure DisplayTenMarker(lay,col,mc:integer;px,py,an,sc:double);
const
   DOT_SIZE = 5 ;    // _}[Jdot̑傫ialj
var
   c,cc : integer ;
   sz : double ;
   w1,w2,w3,w4,w5,w6 : double ;
   x1,y1 : integer ;
   // i1 : integer ;
   e : TMatrix ;
begin
   // _}[JENbsO`FbN
   if (mc = 3) then begin
      // dot
      sz := DOT_SIZE/mm_dot ;
   end
   else begin
      // dotȊO
      sz := 2.5*sc*Sqrt(2.0) ;
   end;
   if (Clip1xyPoint(px,py,sz,sz, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   DisplayLayCol1(lay,col,c,cc);    // F
   gp.G_SetWidth(1);
   //
   sz := 2.5/2.0*sc ;
   case(mc)of
   1: begin
         // asterisk
         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(30.0/180.0*Pi) ;
         w6 := py+sz*Sin(30.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(150.0/180.0*Pi) ;
         w6 := py+sz*Sin(150.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   2: begin
         // circle
         {
         Z2D(x1,y1, px,py);
         i1 := Trunc(sz*mm_dot);
         gp.G_Circle(x1,y1,i1);
         }
         MtxSetE(e);
         DisplayCircle(lay,col,1,1, px,py,sz,e);
      end;
   3: begin
         // dot
         Z2D(x1,y1, px,py);
         gp.G_CircleF(x1,y1,DOT_SIZE);
      end;
   4: begin
         // plus
         w5 := px-sz ;
         w6 := py ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   5: begin
         // square
         w5 := px-sz ;
         w6 := py-sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz ;
         w6 := py-sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py+sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px-sz ;
         w6 := py+sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px-sz ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px-sz ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   6: begin
         // triangle
         sz := 2.5*2.0/3.0*sc ;
         w5 := px+sz*Cos(90.0/180.0*Pi) ;
         w6 := py+sz*Sin(90.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(90.0/180.0*Pi) ;
         w6 := py+sz*Sin(90.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   7: begin
         // X
         w5 := px-sz ;
         w6 := py ;
         Rev(w1,w2, w5,w6, px,py, an+0.25*Pi);
         w5 := px+sz ;
         w6 := py ;
         Rev(w3,w4, w5,w6, px,py, an+0.25*Pi);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an+0.25*Pi);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an+0.25*Pi);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   end;
end;

// ̕\
procedure DisplayLine(lay,col,ltp,wid:integer;px1,py1,px2,py2:double);
var
   c,cc,l,w, i : integer ;
   ww, d1 : double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then begin
      DisplayLineSub1(px1,py1,px2,py2);
   end
   else begin
      i := 0 ;
      d1:= 0.0;
      DisplayLineSub2(l,i,d1, px1,py1,px2,py2);
   end;
end;

// ܐ̕\
procedure DisplayLines(lay,col,ltp,wid,num:integer;vx,vy:array of double);
var
   c,cc,l,w, i,j : integer ;
   ww, d1 : double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then begin
      for j:=1 to num-1 do begin
         DisplayLineSub1(vx[j-1],vy[j-1], vx[j],vy[j]);
      end;
   end
   else begin
      i := 0 ;
      d1:= 0.0 ;
      for j:=1 to num-1 do begin
         DisplayLineSub2(l,i,d1, vx[j-1],vy[j-1], vx[j],vy[j]);
      end;
   end;
end;

// ~̕\
procedure DisplayCircle(lay,col,ltp,wid:integer;px,py,pr:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
begin
   // ~ENbsO`FbN
   x1 := px-pr;   y1 := py-pr;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+pr;   y2 := py-pr;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+pr;   y3 := py+pr;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-pr;   y4 := py+pr;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := pr*Cos(0.25*Pi) ;
   y2 := pr*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(2.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := 2.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := 0.0 ;
   x1 := px + pr*Cos(aa);
   y1 := py + pr*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + pr*Cos(aa);
      y2 := py + pr*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ~ʂ̕\
procedure DisplayArc(lay,col,ltp,wid,dir:integer;px,py,pr,sa,ea:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
begin
   // ~ENbsO`FbN
   x1 := px-pr;   y1 := py-pr;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+pr;   y2 := py-pr;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+pr;   y3 := py+pr;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-pr;   y4 := py+pr;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   if (dir <> 0) then swapD(sa,ea);
   aa := ea - sa ;
   if (aa < 0.0) then aa := aa + 360.0 ;
   if (dir <> 0) then begin
      swapD(sa,ea);
      aa := -aa ;
   end;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := pr*Cos(0.25*Pi) ;
   y2 := pr*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(Abs(aa)/180.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := aa/180.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := sa/180.0*Pi ;
   x1 := px + pr*Cos(aa);
   y1 := py + pr*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + pr*Cos(aa);
      y2 := py + pr*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ȉ~̕\
procedure DisplayEllipse(lay,col,ltp,wid:integer;px,py,rx,ry,ra:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
   tr,tr1 : TMatrix ;
begin
   // ȉ~ENbsO`FbN
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,ra);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px-rx;   y1 := py-ry;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+rx;   y2 := py-ry;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+rx;   y3 := py+ry;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-rx;   y4 := py+ry;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := rx*Cos(0.25*Pi) ;
   y2 := ry*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(2.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := 2.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := 0.0 ;
   x1 := px + rx*Cos(aa);
   y1 := py + ry*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + rx*Cos(aa);
      y2 := py + ry*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ȉ~ʂ̕\
procedure DisplayEllipseArc(lay,col,ltp,wid,dir:integer;px,py,rx,ry,ra,sa,ea:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
   tr,tr1 : TMatrix ;
begin
   // ȉ~ENbsO`FbN
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,ra);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px-rx;   y1 := py-ry;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+rx;   y2 := py-ry;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+rx;   y3 := py+ry;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-rx;   y4 := py+ry;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   if (dir <> 0) then swapD(sa,ea);
   aa := ea - sa ;
   if (aa < 0.0) then aa := aa + 360.0 ;
   if (dir <> 0) then begin
      swapD(sa,ea);
      aa := -aa ;
   end;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := rx*Cos(0.25*Pi) ;
   y2 := ry*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(Abs(aa)/180.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := aa/180.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := sa/180.0*Pi ;
   x1 := px + rx*Cos(aa);
   y1 := py + ry*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + rx*Cos(aa);
      y2 := py + ry*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ̕\
procedure DisplayText(lay,col,fon,bp,dir:integer;px,py,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   tr,tr1 : TMatrix ;
   dx,dy,x1,y1,x2,y2,x3,y3,x4,y4,ma,mx,my,w1,w2,w3,w4,w5,mh1,mw1,mh2,mw2 : double ;
   c,cc,at,l1,i,ix,iy : integer ;
   fo,s1 : string ;
begin
   l1 := Length(st);    // 
   if (l1 = 0) then exit ;

   // _ɍ킹
   case(bp)of
   2: begin   // 2:
         dx := -tw/2.0 ;
         dy := 0.0 ;
      end;
   3: begin   // 3:E
         dx := -tw ;
         dy := 0.0 ;
      end;
   4: begin   // 4:
         dx := 0.0 ;
         dy := -th/2.0 ;
      end;
   5: begin   // 5:
         dx := -tw/2.0 ;
         dy := -th/2.0 ;
      end;
   6: begin   // 6:E
         dx := -tw ;
         dy := -th/2.0 ;
      end;
   7: begin   // 7:
         dx := 0.0 ;
         dy := -th ;
      end;
   8: begin   // 8:
         dx := -tw/2.0 ;
         dy := -th ;
      end;
   9: begin   // 9:E
         dx := -tw ;
         dy := -th ;
      end;
   else begin // 1:
         dx := 0.0 ;
         dy := 0.0 ;
      end;
   end;
   px := px + dx ;
   py := py + dy ;
   // --- ENbsO`FbN ---
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,an);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px;      y1 := py;      MtxXY(x1,y1, x1,y1, t);
   x2 := px+tw;   y2 := py;      MtxXY(x2,y2, x2,y2, t);
   x3 := px+tw;   y3 := py+th;   MtxXY(x3,y3, x3,y3, t);
   x4 := px;      y4 := py+th;   MtxXY(x4,y4, x4,y4, t);

   // }ɂό`镶`Aό`Ȃ悤K
   ma := dAngle((x2-x1),(y2-y1));   // ̊px
   mx := Dist(x1,y1, x2,y2);        // ͈͕
   my := Dist(x1,y1, x4,y4);        // ͈͍
   w1 := dAngle((x4-x1),(y4-y1)) - ma ;
   my := Abs(my*Sin(w1/180.0*Pi));  // VE͈͍

   // `͍_Ȃ̂łɍ킹s(tr1)쐬
   w1 := RevX(0.0,my,0.0,0.0,ma/180.0*Pi);
   w2 := RevY(0.0,my,0.0,0.0,ma/180.0*Pi);
   MtxMove(tr1, w1,w2);
   tr1:= MtxMult(t, tr1) ;
   // ČvZ
   x3 := px+tw;   y3 := py;      MtxXY(x3,y3, x3,y3, tr1);
   x4 := px;      y4 := py;      MtxXY(x4,y4, x4,y4, tr1);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   DisplayLayCol1(lay,col,c,cc);    // F
{
   // g\eXg
   gp.G_SetWidth(1);
   DisplayLineSub1(x1,y1,x2,y2);
   DisplayLineSub1(x2,y2,x3,y3);
   DisplayLineSub1(x3,y3,x4,y4);
   DisplayLineSub1(x4,y4,x1,y1);
}
   at := 0 ;
   if (gp.DisplayMode = 0)and(Abs(sl) > LIMIT8) then at := 2;
   if (fon = 0) then fon := CData.zLay[lay-1].Mfont ;
   fo := CData.zFnt[fon-1].name ;   // tHg
   s1 := Copy(fo,1,1);
   if (s1 = '@')or(s1 = '') then fo := Copy(fo,2,Length(fo));

   if (dir = 1) then begin
      // 
      w1 := 0.0;
      w2 := gp.G_TextWidth(at,32,32,fo,st);
      mh1:= th ;                       // sϊO̕
      mw1:= tw - (l1-1.0)*ts ;         // sϊÓ͈̕iԊuj
      mh2:= my ;                       // sϊ̕
      mw2:= mx - (l1-1.0)*ts*mx/tw ;   // sΐ͈̕iԊuj
      w5 := gp.G_TextWidth(at,100,100,fo,st);
      w4 := 100.0*mw1/w5;
      w5 := 100.0*mw2/w5;
      for i:=1 to l1 do begin
         s1 := Copy(st,i,1);
         w3 := gp.G_TextWidth(at,32,32,fo,s1) / w2 ;
         // 1Pʂ̃NbsO`FbN
         x1 := px+w1;      y1 := py;      MtxXY(x1,y1, x1,y1, t);
         x2 := px+w1+w4;   y2 := py;      MtxXY(x2,y2, x2,y2, t);
         x3 := px+w1+w4;   y3 := py;      MtxXY(x3,y3, x3,y3, tr1);
         x4 := px+w1;      y4 := py;      MtxXY(x4,y4, x4,y4, tr1);
         if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) < 2) then begin
            x1 := px + w1 ;
            y1 := py ;
            MtxXY(x1,y1, x1,y1, tr1);
            Z2D(ix,iy, x1,y1);
            gp.G_Text1(at,ix,iy,Round(mh2*mm_dot),Round(w5*mm_dot),ma,sl,fo,s1);
         end;
         w1 := w1 + mw1*w3 + ts;
      end;
   end
   else begin
      // c
      w1 := 0.0;
      w2 := 0.0;
      w5 := 0.0;
      for i:=1 to l1 do begin
         s1 := Copy(st,i,1);
         if (HanCheck(s1))or(MojiRotCheck(s1)) then begin
            // p,Sp]
            w2 := w2 + gp.G_TextWidth(0,32,32,fo,s1);
            w5 := w5 + gp.G_TextWidth(at,100,100,fo,s1);
         end
         else begin
            // Sp
            w2 := w2 + 32.0 ;
            w5 := w5 + 100.0;
         end;
      end;
      mh1:= th - (l1-1.0)*ts ;         // sϊÓ͈̕iԊuj
    //mw1:= tw ;                       // sϊO͈̕
      mh2:= my - (l1-1.0)*ts*my/th ;   // sΐ͈̕iԊuj
      mw2:= mx ;                       // sϊ͈̕
      w5 := 100.0*mh2/w5;
      dx := px ;
      dy := py ;
      MtxXY(dx,dy, dx,dy, t);
      for i:=1 to l1 do begin
         s1 := Copy(st,i,1);
         if (HanCheck(s1))or(MojiRotCheck(s1)) then begin
            // p,Sp]
            w3 := gp.G_TextWidth(0,32,32,fo,s1) / w2 ;
         end
         else begin
            // Sp
            w3 := 32.0 / w2 ;
         end;
         // 1Pʂ̃NbsO`FbN
         dRev(x1,y1,dx    ,dy+my-w1       ,dx,dy,ma);
         dRev(x2,y2,dx    ,dy+my-w1-mh2*w3,dx,dy,ma);
         dRev(x3,y3,dx+mw2,dy+my-w1-mh2*w3,dx,dy,ma);
         dRev(x4,y4,dx+mw2,dy+my-w1       ,dx,dy,ma);
         if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) < 2) then begin
            if (HanCheck(s1))or(MojiRotCheck(s1)) then begin
               // p
               dRev(x2,y2,dx+mw2,dy+my-w1,dx,dy,ma);
               Z2D(ix,iy, x2,y2);
               gp.G_Text1(0,ix,iy,Round(mw2*mm_dot),Round(w5*mm_dot),ma-90.0,0.0,fo,s1);
               // c̔p90]ESpƂԂ̂ŃXg͖
            end
            else begin
               // Sp
               mw1:= 1.0;
               w4 := mw2/2.0 - mw2*gp.G_TextWidth(at,32,32,fo,s1)/32.0/2.0 ;
               if (w4 < 0.0) then begin
                  mw1:= 32.0 / gp.G_TextWidth(at,32,32,fo,s1) ;
                  w4 := 0.0;
               end;
               if (MojiMoveCheck(s1)) then begin
                  w4 := w4 + 0.4*mw2 ;
               end;
               dRev(x2,y2,dx+w4,dy+my-w1,dx,dy,ma);
               Z2D(ix,iy, x2,y2);
               gp.G_Text1(at,ix,iy,Round(w5*mm_dot),Round(mw1*mw2*mm_dot),ma,sl,fo,s1);
            end;
         end;
         w1 := w1 + mh2*w3 + ts*my/th;
      end;
   end;
end;

// xWFȐ̕\@Tu
procedure DisplayBezierSub(var xp,yp:double;t,x1,x2,x3,x4, y1,y2,y3,y4:double);
var
   t0,t1,t2,t3 : double ;
begin
   t0 := (1.0-t)*(1.0-t)*(1.0-t);
   t1 := 3.0*t*(1.0-t)*(1.0-t);
   t2 := 3.0*(1.0-t)*t*t;
   t3 := t*t*t;
   xp := t0*x1 + t1*x2 + t2*x3 + t3*x4 ;
   yp := t0*y1 + t1*y2 + t2*y3 + t3*y4 ;
end;

// xWFȐ̕\
procedure DisplayBezier(lay,col,ltp,wid,sp,num:integer;vx,vy:array of double);
var
   c,cc,l,w, i,j,k : integer ;
   ww, d1 ,t,x1,y1,x2,y2 : double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then begin
      for j:=0 to ((num-1) div 3)-1 do begin
         t := 0.0;
         DisplayBezierSub(x1,y1, t,vx[j*3],vx[j*3+1],vx[j*3+2],vx[j*3+3],
                                   vy[j*3],vy[j*3+1],vy[j*3+2],vy[j*3+3]);
         for k:=1 to sp do begin
            t := t + 1.0/sp ;
            DisplayBezierSub(x2,y2, t,vx[j*3],vx[j*3+1],vx[j*3+2],vx[j*3+3],
                                      vy[j*3],vy[j*3+1],vy[j*3+2],vy[j*3+3]);
            DisplayLineSub1(x1,y1, x2,y2);
            x1:= x2;
            y1:= y2;
         end;
      end;
   end
   else begin
      i := 0 ;
      d1:= 0.0 ;
      for j:=0 to ((num-1) div 3)-1 do begin
         t := 0.0;
         DisplayBezierSub(x1,y1, t,vx[j*3],vx[j*3+1],vx[j*3+2],vx[j*3+3],
                                   vy[j*3],vy[j*3+1],vy[j*3+2],vy[j*3+3]);
         for k:=1 to sp do begin
            t := t + 1.0/sp ;
            DisplayBezierSub(x2,y2, t,vx[j*3],vx[j*3+1],vx[j*3+2],vx[j*3+3],
                                      vy[j*3],vy[j*3+1],vy[j*3+2],vy[j*3+3]);
            DisplayLineSub2(l,i,d1, x1,y1, x2,y2);
            x1:= x2;
            y1:= y2;
         end;
      end;
   end;
end;

// aXvCȐ̕\@Tu
procedure DisplayBsplineSub(var xp,yp:double;t,x1,x2,x3,x4, y1,y2,y3,y4:double);
var
   t0,t1,t2,t3 : double ;
begin
   t0 := (1.0-t)*(1.0-t)*(1.0-t)/6.0;
   t1 := 0.5*t*t*t - t*t + 2.0/3.0;
   t2 :=-0.5*t*t*t + 0.5*t*t + 0.5*t + 1.0/6.0;
   t3 := t*t*t/6.0;
   xp := t0*x1 + t1*x2 + t2*x3 + t3*x4 ;
   yp := t0*y1 + t1*y2 + t2*y3 + t3*y4 ;
end;

// aXvCȐ̕\
procedure DisplayBspline(lay,col,ltp,wid,oc,sp,num:integer;vx,vy:array of double);
var
   fl : Boolean ;
   c,cc,l,w, i,j,k : integer ;
   ww, d1 ,t,x1,y1,x2,y2,x3,y3,x4,y4,px1,py1,px2,py2 : double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then fl := True;

   k := 0 ;
   d1:= 0.0 ;
   i := 0;
   while(i < num) do begin
      if (i = 0) then begin
         if (oc = 1) then begin
            // JȐ
            x1 := vx[0];
            y1 := vy[0];
         end
         else begin
            // Ȑ
            x1 := vx[num-2];
            y1 := vy[num-2];
         end;
      end
      else begin
         x1 := vx[i-1];
         y1 := vy[i-1];
      end;
      x2 := vx[i];
      y2 := vy[i];
      if (i >= num-1) then begin
         if (oc = 1)or(num < 2) then begin
            // JȐ
            x3 := vx[num-1];
            y3 := vy[num-1];
         end
         else begin
            // Ȑ
            x3 := vx[1];
            y3 := vy[1];
         end;
      end
      else begin
         x3 := vx[i+1];
         y3 := vy[i+1];
      end;
      if (i >= num-2) then begin
         if (oc = 1)or(num < 3) then begin
            // JȐ
            x4 := vx[num-1];
            y4 := vy[num-1];
         end
         else begin
            // Ȑ
            x4 := vx[i-num+3];
            y4 := vy[i-num+3];
         end;
      end
      else begin
         x4 := vx[i+2];
         y4 := vy[i+2];
      end;
      //
      t  := 0.0;
      DisplayBsplineSub(px1,py1, t,x1,x2,x3,x4, y1,y2,y3,y4);
      if (i = 0)and(oc = 1) then begin
         px1 := vx[0];
         py1 := vy[0];
      end;
      for j:=1 to sp do begin
         t := t + 1.0/sp;
         DisplayBsplineSub(px2,py2, t,x1,x2,x3,x4, y1,y2,y3,y4);
         if (fl) then
            DisplayLineSub1(px1,py1, px2,py2)
         else
            DisplayLineSub2(l,k,d1, px1,py1, px2,py2);
         px1 := px2;
         py1 := py2;
      end;
      i := i + 1;
   end;
end;

// XvCȐ̕\@TuP
//    J[fBiXvC
procedure DisplaySplineSub1(var xp,yp:double;t,av,x0,x1,x2,x3, y0,y1,y2,y3:double);
var
   t0,t1,t2,t3,dx1,dy1,dx2,dy2 : double ;
begin
   t0 := 2.0*t*t*t - 3.0*t*t + 1.0;
   t1 :=-2.0*t*t*t + 3.0*t*t;
   t2 := t*t*t - 2.0*t*t + t;
   t3 := t*t*t - t*t;
   dx1 := av*(x2-x0);
   dy1 := av*(y2-y0);
   dx2 := av*(x3-x1);
   dy2 := av*(y3-y1);
   xp := t0*x1 + t1*x2 + t2*dx1 + t3*dx2 ;
   yp := t0*y1 + t1*y2 + t2*dy1 + t3*dy2 ;
end;

// XvCȐ̕\@TuQ
//    de boor-cox̑QɂBXvC֐̌vZ
procedure DisplaySplineSub2(tn,nmax:integer;t:double;var tv,bn:array of double);
var
   i,j,k : integer ;
   a0,a1,a2 : double ;
begin
   k := 0;
   for i:=0 to nmax-1 do
      bn[i] := 0.0 ;
   for i:=0 to nmax-1 do begin
      if (tv[i]-LIMIT8 <= t)and(t < tv[i+1]-LIMIT8) then begin
         bn[i] := 1.0 ;
         k := i ;
      end;
   end;
   if (tv[nmax-1]-LIMIT8 <= t)and(t <= tv[nmax]+LIMIT8) then begin
      bn[nmax-1] := 1.0 ;
      k := nmax-1 ;
   end;

   for i:=1 to 3 do begin
      for j:=0 to nmax-1 do
         bn[j + nmax*i] := 0.0 ;
      for j:=k-i to k do begin
         a1 := 0.0;
         a2 := 0.0;
         a0 := tv[j+(i+1)-1] - tv[j] ;
         if (Abs(a0) > LIMIT8) then
            a1 := (t - tv[j]) * bn[j + nmax*(i-1)] / a0 ;
         a0 := tv[j+(i+1)] - tv[j+1] ;
         if (Abs(a0) > LIMIT8) then
            a2 := (tv[j+(i+1)] - t) * bn[j+1 + nmax*(i-1)] / a0 ;
         bn[j + nmax*i] := a1 + a2 ;
      end;
   end;
end;

// XvCȐ̕\@TuR
//    de boor-cox̑QɂBXvC֐̂W̌vZ
procedure DisplaySplineSub3(tn,nmax,kai:integer;t:double;var tv,bn1,bn2:array of double);
var
   i,j : integer ;
   a0,a1,a2 : double ;
begin
   for j:=0 to nmax-1 do
      bn2[j] := 0.0 ;

   for i:=1 to (kai-1) do begin
      for j:=0 to nmax-1 do begin
         a1 := 0.0;
         a2 := 0.0;
         a0 := tv[j+(i+1)-1] - tv[j] ;
         if (Abs(a0) > LIMIT8) then
            a1 := bn1[j + nmax*(i-1)] / a0 ;
         a0 := tv[j+(i+1)] - tv[j+1] ;
         if (Abs(a0) > LIMIT8) then
            a2 := bn1[j+1 + nmax*(i-1)] / a0 ;
         bn2[j + nmax*i] := (i+1.0 - 1.0)*( a1 - a2 );
      end;
   end;
end;

// XvCȐ̕\
procedure DisplaySpline(lay,col,ltp,wid,stp,oc,sp,num:integer;av:double;vx,vy:array of double);
var
   fl : Boolean ;
   c,cc,l,w, i,j,k : integer ;
   ww, d1 ,t,x0,y0,x1,y1,x2,y2,x3,y3,px1,py1,px2,py2 : double ;
   //
   m1,m2 : integer ;
   qx,qy : array of double ;
   //
   qn  : integer ;      // _̐
   jisu: integer ;      // 
   kai : integer ;      // K
   tn  : integer ;         // mbgxNg̐
   tv : array of double ;  // mbgxNg
   nmax : integer ;        // ֐̐
   bn : array of double ;  // ֐
   bn1: array of double ;  // ֐̂PW
   bn2: array of double ;  // ֐̂QW
   d : double ;
   maxq,jj : integer ;
   q,x,y : array of double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then fl := True;

   k := 0 ;
   d1:= 0.0 ;
   Case(stp)of
   1: begin
         // J[fBiXvCȐ
         k := 0 ;
         d1:= 0.0 ;
         for i:=0 to num-2 do begin
            if (i > 0) then begin
               x0 := vx[i-1];
               y0 := vy[i-1];
            end
            else begin
               if (oc = 1) then begin
                  // JȐ
                  x0 := vx[0];
                  y0 := vy[0];
               end
               else begin
                  // Ȑ
                  x0 := vx[num-2];
                  y0 := vy[num-2];
               end;
            end;
            x1 := vx[i];
            y1 := vy[i];
            x2 := vx[i+1];
            y2 := vy[i+1];
            if (i < (num-2)) then begin
               x3 := vx[i+2];
               y3 := vy[i+2];
            end
            else begin
               if (oc = 1) then begin
                  // JȐ
                  x3 := vx[i+1];
                  y3 := vy[i+1];
               end
               else begin
                  // Ȑ
                  x3 := vx[1];
                  y3 := vy[1];
               end;
            end;
            //
            t  := 0.0;
            DisplaySplineSub1(px1,py1, t,av, x0,x1,x2,x3, y0,y1,y2,y3);
            for j:=1 to sp do begin
               t := t + 1.0/sp;
               DisplaySplineSub1(px2,py2, t,av, x0,x1,x2,x3, y0,y1,y2,y3);
               if (fl) then
                  DisplayLineSub1(px1,py1, px2,py2)
               else
                  DisplayLineSub2(l,k,d1, px1,py1, px2,py2);
               px1 := px2;
               py1 := py2;
            end;
         end;
      end;
   2: begin
         // xWF
         // r̐_Zo邽߂̍s𐶐
         m1 := (num-1)*2+1;
         m2 := (num-1)*2;
         SetLength(qx,m1*m2);
         SetLength(qy,m1*m2);
         for i:=0 to m1*m2-1 do
            qx[i] := 0.0;
         for i:=0 to num-3 do begin
            qx[(i*2  )*m1+i*2+1] := 1.0;
            qx[(i*2  )*m1+i*2+2] := 1.0;
            qx[(i*2+1)*m1+i*2  ] := 1.0;
            qx[(i*2+1)*m1+i*2+1] :=-2.0;
            qx[(i*2+1)*m1+i*2+2] := 2.0;
            qx[(i*2+1)*m1+i*2+3] :=-1.0;
         end;
         if (oc = 1) then begin
            // JȐ
            qx[((num-2)*2  )*m1  ]           := 2.0;
            qx[((num-2)*2  )*m1+1]           :=-1.0;
            qx[((num-2)*2+1)*m1+(num-2)*2  ] :=-1.0;
            qx[((num-2)*2+1)*m1+(num-2)*2+1] := 2.0;
         end
         else begin
            // Ȑ
            qx[((num-2)*2  )*m1  ]           := 1.0;
            qx[((num-2)*2  )*m1+(num-2)*2+1] := 1.0;
            qx[((num-2)*2+1)*m1  ]           := 2.0;
            qx[((num-2)*2+1)*m1+1]           :=-1.0;
            qx[((num-2)*2+1)*m1+(num-2)*2  ] := 1.0;
            qx[((num-2)*2+1)*m1+(num-2)*2+1] :=-2.0;
         end;
         for i:=0 to m1*m2-1 do
            qy[i] := qx[i] ;
         // sɍWlZbg
         for i:=0 to num-3 do begin
            qx[(i*2+1)*m1-1] := 2.0*vx[i+1];
            qy[(i*2+1)*m1-1] := 2.0*vy[i+1];
         end;
         if (oc = 1) then begin
            // JȐ
            qx[((num-2)*2+1)*m1-1] := vx[0];
            qy[((num-2)*2+1)*m1-1] := vy[0];
            qx[((num-2)*2+2)*m1-1] := vx[num-1];
            qy[((num-2)*2+2)*m1-1] := vy[num-1];
         end
         else begin
            // Ȑ
            qx[((num-2)*2+1)*m1-1] := 2.0*vx[num-1];
            qy[((num-2)*2+1)*m1-1] := 2.0*vy[num-1];
         end;
         // s
         gauss(m1,m2,qx);
         gauss(m1,m2,qy);
         // }
         for i:=0 to num-2 do begin
            x0 := vx[i];
            y0 := vy[i];
            x1 := qx[(i*2+1)*m1-1];
            y1 := qy[(i*2+1)*m1-1];
            x2 := qx[(i*2+2)*m1-1];
            y2 := qy[(i*2+2)*m1-1];
            x3 := vx[i+1];
            y3 := vy[i+1];
            t  := 0.0;
            DisplayBezierSub(px1,py1, t,x0,x1,x2,x3, y0,y1,y2,y3);
            for j:=1 to sp do begin
               t := t + 1.0/sp;
               DisplayBezierSub(px2,py2, t,x0,x1,x2,x3, y0,y1,y2,y3);
               if (fl) then
                  DisplayLineSub1(px1,py1, px2,py2)
               else
                  DisplayLineSub2(l,k,d1, px1,py1, px2,py2);
               px1 := px2;
               py1 := py2;
            end;
         end;
         qx := nil;
         qy := nil;
      end;
   3: begin
         // NUBSimjtH[aXvCȐj
         qn   := num + 2 ;
         jisu := 3;
         kai  := jisu + 1;
         tn   := qn + kai ;
         // mbgxNg
         SetLength(tv,tn);
         tv[0] := 0.0 ;
         tv[1] := 0.0 ;
         tv[2] := 0.0 ;
         tv[3] := 0.0 ;
         t := 0.0 ;
         for i:=0 to num-2 do begin
            d := Dist(vx[i],vy[i], vx[i+1],vy[i+1]);
            t := t + d ;
            tv[4+i] := t ;
         end;
         tv[3+num] := tv[2+num] ;
         tv[4+num] := tv[2+num] ;
         tv[5+num] := tv[2+num] ;
         //
         nmax := qn ;
         SetLength(bn , nmax*4);
         SetLength(bn1, nmax*4);
         SetLength(bn2, nmax*4);
         SetLength(qx, (qn)*(qn+1));
         SetLength(qy, (qn)*(qn+1));
         for i:=0 to ((qn)*(qn+1)-1) do begin
            qx[i] := 0.0;
            qy[i] := 0.0;
         end;
         // aXvC֐@@ʉߓ__
         for i:=0 to num-1 do begin
            t := tv[i+jisu] ;
            DisplaySplineSub2(tn,nmax,t, tv,bn);
            for j:=0 to nmax-1 do begin
               qx[j +(i)*(qn+1)] := bn[j + nmax*3] ;
               qy[j +(i)*(qn+1)] := bn[j + nmax*3] ;
            end;
            qx[nmax +(i)*(qn+1)] := vx[i];
            qy[nmax +(i)*(qn+1)] := vy[i];
         end;
         if (oc = 1) then begin
            // JȐ[̋ȗ=0Ql=0
            i := 0;
            t := tv[i+jisu] ;
            DisplaySplineSub2(tn,nmax,t, tv,bn);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn ,bn1);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn1,bn2);
            for j:=0 to nmax-1 do begin
               qx[j +(num)*(qn+1)] := bn2[j + nmax*3] ;
               qy[j +(num)*(qn+1)] := bn2[j + nmax*3] ;
            end;
            qx[nmax +(num)*(qn+1)] := 0.0 ;
            qy[nmax +(num)*(qn+1)] := 0.0 ;
            i := num-1;
            t := tv[i+jisu] ;
            DisplaySplineSub2(tn,nmax,t, tv,bn);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn ,bn1);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn1,bn2);
            for j:=0 to nmax-1 do begin
               qx[j +(num+1)*(qn+1)] := bn2[j + nmax*3] ;
               qy[j +(num+1)*(qn+1)] := bn2[j + nmax*3] ;
            end;
            qx[nmax +(num+1)*(qn+1)] := 0.0 ;
            qy[nmax +(num+1)*(qn+1)] := 0.0 ;
         end
         else begin
            // Ȑ[̋ȗ=0Ql̍=0
            //       @[̐ڐ=0Pl̍=0
            i := 0;
            t := tv[i+jisu] ;
            DisplaySplineSub2(tn,nmax,t, tv,bn);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn ,bn1);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn1,bn2);
            for j:=0 to nmax-1 do begin
               qx[j +(num)  *(qn+1)] := bn2[j + nmax*3] ;
               qy[j +(num)  *(qn+1)] := bn2[j + nmax*3] ;
               qx[j +(num+1)*(qn+1)] := bn1[j + nmax*3] ;
               qy[j +(num+1)*(qn+1)] := bn1[j + nmax*3] ;
            end;
            i := num-1;
            t := tv[i+jisu] ;
            DisplaySplineSub2(tn,nmax,t, tv,bn);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn ,bn1);
            DisplaySplineSub3(tn,nmax,kai,t, tv,bn1,bn2);
            for j:=0 to nmax-1 do begin
               qx[j +(num)  *(qn+1)] := qx[j +(num)  *(qn+1)] - bn2[j + nmax*3] ;
               qy[j +(num)  *(qn+1)] := qy[j +(num)  *(qn+1)] - bn2[j + nmax*3] ;
               qx[j +(num+1)*(qn+1)] := qx[j +(num+1)*(qn+1)] - bn1[j + nmax*3] ;
               qy[j +(num+1)*(qn+1)] := qy[j +(num+1)*(qn+1)] - bn1[j + nmax*3] ;
            end;
            qx[nmax +(num)  *(qn+1)] := 0.0 ;
            qy[nmax +(num)  *(qn+1)] := 0.0 ;
            qx[nmax +(num+1)*(qn+1)] := 0.0 ;
            qy[nmax +(num+1)*(qn+1)] := 0.0 ;
         end;
         // s񎮂
         gauss(qn+1,qn,qx);
         gauss(qn+1,qn,qy);
         // eԖɕ`s
         maxq := (jisu+1) + kai ; // 1ԕ
         SetLength(q, maxq);
         SetLength(x, jisu+1);
         SetLength(y, jisu+1);
         for j:=0 to (num-2) do begin
            // mbgxNg
            for i:=0 to (maxq-1) do
               q[i] := tv[i+j];
            // _
            for i:=0 to jisu do begin
               x[i] := qx[qn+(i+j)*(qn+1)] ;
               y[i] := qy[qn+(i+j)*(qn+1)] ;
            end;
            px1 := 0.0 ;
            py1 := 0.0 ;
            t := q[kai-1] ;
            for i:=0 to sp-1 do begin
               px2 := 0.0 ;
               py2 := 0.0 ;
               for jj:=0 to kai-1 do begin
                  DisplaySplineSub2(maxq,kai+2,t, q,bn);
                  px2 := px2 + bn[jj + (kai+2)*3]*x[jj] ;
                  py2 := py2 + bn[jj + (kai+2)*3]*y[jj] ;
               end;
               if (i > 0) then begin
                  if (fl) then
                     DisplayLineSub1(px1,py1, px2,py2)
                  else
                     DisplayLineSub2(l,k,d1, px1,py1, px2,py2);
               end;
               px1 := px2;
               py1 := py2;
               t := t + (q[kai]-q[kai-1])*1.0/sp ;
            end;
            if (fl) then
               DisplayLineSub1(px1,py1, vx[j+1],vy[j+1])
            else
               DisplayLineSub2(l,k,d1, px1,py1, vx[j+1],vy[j+1]);
         end;
         //
         q := nil;
         x := nil;
         y := nil;
         tv := nil;
         bn := nil;
         bn1:= nil;
         bn2:= nil;
         qx := nil;
         qy := nil;
      end;
   end;
end;

// N\ChȐ̕\ TuP
//    N\ChȐ̍W𓾂錳
procedure DisplayClothoidSub1(var x,y:double;p:double);
begin
   x := Cos(Pi*p*p/2.0);
   y := Sin(Pi*p*p/2.0);
end;

// N\ChȐ̕\ TuQ
//    N\ChȐ̍W𓾂@Vv\𗘗p
procedure DisplayClothoidSub2(var x,y:double;A,l:double);
const
   CALC_SEP = 100 ;     // vZ̕
var
   aa,u,h,sx1,sy1,sx2,sy2,p,w1,w2,w3,w4 : double ;
   i : integer ;
begin
   aa := A*Sqrt(Pi);
   u  := l/aa ;   
   h  := u/CALC_SEP;
   sx1:= 0.0;
   sy1:= 0.0;
   sx2:= 0.0;
   sy2:= 0.0;
   i  := 1;
   while(i <= (CALC_SEP-1)) do begin
      p := i*h ;
      DisplayClothoidSub1(w1,w2,p);
      sx1 := sx1 + 4.0*w1 ;
      sy1 := sy1 + 4.0*w2 ;
      i := i + 2;
   end;
   i  := 2;
   while(i <= (CALC_SEP-2)) do begin
      p := i*h ;
      DisplayClothoidSub1(w1,w2,p);
      sx2 := sx2 + 2.0*w1 ;
      sy2 := sy2 + 2.0*w2 ;
      i := i + 2;
   end;
   DisplayClothoidSub1(w1,w2,0.0);
   DisplayClothoidSub1(w3,w4,u);
   x := aa*h*(w1 + sx1 + sx2 + w3)/3.0 ;
   y := aa*h*(w2 + sy1 + sy2 + w4)/3.0 ;
end;

// N\ChȐ̕\
procedure DisplayClothoid(lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double;t:TMatrix);
var
   tr,tr1 : TMatrix ;
   c,cc,l,w, i,k : integer ;
   ww, d1 : double ;
   fl : Boolean ;
   ls,lt,ll,x1,y1,x2,y2,mx1,my1,mx2,my2,aa : double ;
begin
   MtxRotD(tr, an);
   MtxMove(tr1, bx,by);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;
   k := 0 ;
   d1:= 0.0 ;
   ls:= (l2-l1)/sp ;
   lt:= l1 ;
   ll:= 0.0;
   DisplayClothoidSub2(x1,y1,av,lt);
   if (dir = 1) then y1 := -y1;
   MtxXY(mx1,my1, x1,y1, t);
   for i:=1 to sp do begin
      lt := lt + ls;
      DisplayClothoidSub2(x2,y2,av,lt);
      if (dir = 1) then y2 := -y2;
      if (i = sp) then begin
         // ŏI̒̕␳
         ll := Abs(l2-l1) - ll ;
         aa := Angle(x2-x1,y2-y1);
         x2 := x1 + ll*Cos(aa);
         y2 := y1 + ll*Sin(aa);                  
      end;
      MtxXY(mx2,my2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(mx1,my1,mx2,my2)
      else
         DisplayLineSub2(l,k,d1, mx1,my1,mx2,my2) ;

      ll := ll + Dist(x1,y1,x2,y2);
      x1 := x2 ;
      y1 := y2 ;
      mx1:= mx2 ;
      my1:= my2 ;
   end;
end;

// V{}`̕\
procedure DisplaySymbolZukei(lay,cf,col:integer;nam:string;px,py,an,sc:double;t:TMatrix);
var
   x1,y1,x2,y2,ma : double ;
   tr,tr1 : TMatrix ;
   j,k,o,o1,o2,la,co : integer ;
   lx1,ly1,lx2,ly2,lan,lsc : double ;
   lx,ly : array of double ;
begin
   // ϊsɂpx擾
   x1 :=  0.0;    y1 := 0.0;     MtxXY(x1,y1, x1,y1, t);
   x2 := 10.0;    y2 := 0.0;     MtxXY(x2,y2, x2,y2, t);
   ma := dAngle((x2-x1),(y2-y1));
   ma := ma + an ;   // V{}`̊pxZ
   // ϊsɂʒu擾
   x1 := px ;     y1 := py ;     MtxXY(x1,y1, x1,y1, t);
   // ϊs쐬iꉞ t ͏㏑Ȃ悤ɂĂj
   MtxScale(tr, sc,sc);
   MtxRotD(tr1, ma);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, x1,y1);
   tr := MtxMult(tr,tr1) ;
   //
   j := CData.FZukeiNameCheck(0,nam) ;
   if (j < 0) then begin
      with CData.sDef[-j-1] do begin
         for o:=0 to mOrdN-1 do begin
            o1 := mOrd[o].DataType ;
            o2 := mOrd[o].DataNo ;
            case (o1) of
            1: begin
                  // _}[JEf[^\
                  with mTen[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, tr);
                     lan := (rotate_angle + ma)/180.0*Pi ;
                     lsc := Scale * sc ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayTenMarker(la,co,marker_code,lx1,ly1,lan,lsc);
                  end;
               end;
            2: begin
                  // f[^\
                  with mLin[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, tr);
                     MtxXY(lx2,ly2, end_x  ,end_y  , tr);
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayLine(la,co,Ltype,line_width,lx1,ly1,lx2,ly2);
                  end;
               end;
            3: begin
                  // ܐf[^\
                  with mLns[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], tr);
                     end;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayLines(la,co,Ltype,line_width,Number,lx,ly);
                  end;
               end;
            4: begin
                  // ~f[^\
                  with mCir[o2] do begin
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayCircle(la,co,Ltype,line_width,Center_x,Center_y,Radius,tr);
                  end;
               end;
            5: begin
                  // ~ʃf[^\
                  with mArc[o2] do begin
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayArc(la,co,Ltype,line_width,Direction,Center_x,Center_y,Radius,start_angle,end_angle,tr);
                  end;
               end;
            6: begin
                  // ȉ~f[^\
                  with mEll[o2] do begin
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayEllipse(la,co,Ltype,line_width,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,tr);
                  end;
               end;
            7: begin
                  // ȉ~ʃf[^\
                  with mEAr[o2] do begin
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayEllipseArc(la,co,Ltype,line_width,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,tr);
                  end;
               end;
            8: begin
                  // f[^\
                  with mTxt[o2] do begin
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayText(la,co,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            9: begin
                  // xWFȐf[^\
                  with mBez[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], tr);
                     end;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayBezier(la,co,Ltype,line_width,sep,Number,lx,ly);
                  end;
               end;
            10:begin
                  // aXvCȐf[^\
                  with mBsp[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], tr);
                     end;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayBspline(la,co,Ltype,line_width,open_close,sep,Number,lx,ly);
                  end;
               end;
            11:begin
                  // XvCȐf[^\
                  with mSpl[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], tr);
                     end;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplaySpline(la,co,Ltype,line_width,Stype,open_close,sep,Number,Aval,lx,ly);
                  end;
               end;
            12:begin
                  // N\ChȐf[^\
                  with mClo[o2] do begin
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayClothoid(la,co,Ltype,line_width,Direction,sep, base_x,base_y,Aval,Angle,start_length,end_length,tr);
                  end;
               end;
            end;
         end;
      end;
      lx := nil;
      ly := nil;
   end
   else begin
      // V{݂Ȃꍇ͕\(W=2,H=2,S=0)
      if (lay = 0) then lay := 1;
      if (cf = 0) then col := 0;
      lx2 := 2.0*Length(nam);
      DisplayText(lay,col,0,5,1, 0.0,0.0, 2.0,lx2,0.0, 0.0,0.0,nam,tr);
   end;
end;



// Sf[^\
procedure DisplayAllData ;
var
   o,o1,o2, i,j,k : integer ;
   lx1,ly1,lx2,ly2,lx3,ly3 : double ;
   an : double ;
   lx,ly : array of double ;
   e : TMatrix ;
begin
   MtxSetE(e);
   // \Lvf^p@ef[^\
   for o:=0 to CData.dOrdN-1 do begin
      o1 := CData.dOrd[o].DataType ;
      o2 := CData.dOrd[o].DataNo ;
      case (o1) of
      1: begin
            // _}[JEf[^\
            with CData.dTen[o2] do begin
               an := rotate_angle/180.0*Pi ;
               DisplayTenMarker(Layer,Color,marker_code,start_x,start_y,an,Scale);
            end;
         end;
      2: begin
            // f[^\
            with CData.dLin[o2] do begin
               DisplayLine(Layer,Color,Ltype,line_width,start_x,start_y,end_x,end_y);
            end;
         end;
      3: begin
            // ܐf[^\
            with CData.dLns[o2] do begin
               DisplayLines(Layer,Color,Ltype,line_width,Number,X,Y);
            end;
         end;
      4: begin
            // ~f[^\
            with CData.dCir[o2] do begin
               DisplayCircle(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius,e);
            end;
         end;
      5: begin
            // ~ʃf[^\
            with CData.dArc[o2] do begin
               DisplayArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius,start_angle,end_angle,e);
            end;
         end;
      6: begin
            // ȉ~f[^\
            with CData.dEll[o2] do begin
               DisplayEllipse(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,e);
            end;
         end;
      7: begin
            // ȉ~ʃf[^\
            with CData.dEAr[o2] do begin
               DisplayEllipseArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,e);
            end;
         end;
      8: begin
            // f[^\
            with CData.dTxt[o2] do begin
               DisplayText(Layer,Color,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      9: begin
            // xWFȐf[^\
            with CData.dBez[o2] do begin
               DisplayBezier(Layer,Color,Ltype,line_width,sep,Number,X,Y);
            end;
         end;
      10:begin
            // aXvCȐf[^\
            with CData.dBsp[o2] do begin
               DisplayBspline(Layer,Color,Ltype,line_width,open_close,sep,Number,X,Y);
            end;
         end;
      11:begin
            // XvCȐf[^\
            with CData.dSpl[o2] do begin
               DisplaySpline(Layer,Color,Ltype,line_width,Stype,open_close,sep,Number,Aval,X,Y);
            end;
         end;
      12:begin
            // N\ChȐf[^\
            with CData.dClo[o2] do begin
               DisplayClothoid(Layer,Color,Ltype,line_width,Direction,sep, base_x,base_y,Aval,Angle,start_length,end_length,e);
            end;
         end;
      100:begin
            // V{}`f[^\
            with CData.dSzk[o2] do begin
               DisplaySymbolZukei(Layer,color_flag,Color,name,start_x,start_y,rotate_angle,Scale,e);
            end;
         end;
      end;
   end;

   // 􉽗vf^}ȉ@ef[^\
   for i:=0 to CData.zFztN-1 do begin
      j := CData.FZukeiNameCheck(0,CData.zFzt[i].name) ;
      if (j <= 0) then continue ;
      with CData.fDef[j-1] do begin
         for o:=0 to mOrdN-1 do begin
            o1 := mOrd[o].DataType ;
            o2 := mOrd[o].DataNo ;
            case (o1) of
            1: begin
                  // _}[JEf[^\
                  with mTen[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     an := rotate_angle/180.0*Pi ;
                     lx2 := start_x + 10.0*Cos(an);
                     ly2 := start_y + 10.0*Sin(an);
                     MtxXY(lx3,ly3, lx2,ly2, CData.zFzt[i].mtx);
                     an  := Angle(lx3-lx1,ly3-ly1);
                     DisplayTenMarker(Layer,Color,marker_code,lx1,ly1,an,Scale);
                  end;
               end;
            2: begin
                  // f[^\
                  with mLin[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     MtxXY(lx2,ly2, end_x  ,end_y  , CData.zFzt[i].mtx);
                     DisplayLine(Layer,Color,Ltype,line_width,lx1,ly1,lx2,ly2);
                  end;
               end;
            3: begin
                  // ܐf[^\
                  with mLns[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], CData.zFzt[i].mtx);
                     end;
                     DisplayLines(Layer,Color,Ltype,line_width,Number,lx,ly);
                  end;
               end;
            4: begin
                  // ~f[^\
                  with mCir[o2] do begin
                     DisplayCircle(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius,CData.zFzt[i].mtx);
                  end;
               end;
            5: begin
                  // ~ʃf[^\
                  with mArc[o2] do begin
                     DisplayArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            6: begin
                  // ȉ~f[^\
                  with mEll[o2] do begin
                     DisplayEllipse(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,CData.zFzt[i].mtx);
                  end;
               end;
            7: begin
                  // ȉ~ʃf[^\
                  with mEAr[o2] do begin
                     DisplayEllipseArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            8: begin
                  // f[^\
                  with mTxt[o2] do begin
                     DisplayText(Layer,Color,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            9: begin
                  // xWFȐf[^\
                  with mBez[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], CData.zFzt[i].mtx);
                     end;
                     DisplayBezier(Layer,Color,Ltype,line_width,sep,Number,lx,ly);
                  end;
               end;
            10:begin
                  // aXvCȐf[^\
                  with mBsp[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], CData.zFzt[i].mtx);
                     end;
                     DisplayBspline(Layer,Color,Ltype,line_width,open_close,sep,Number,lx,ly);
                  end;
               end;
            11:begin
                  // XvCȐf[^\
                  with mSpl[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], CData.zFzt[i].mtx);
                     end;
                     DisplaySpline(Layer,Color,Ltype,line_width,Stype,open_close,sep,Number,Aval,lx,ly);
                  end;
               end;
            12:begin
                  // N\ChȐf[^\
                  with mClo[o2] do begin
                     DisplayClothoid(Layer,Color,Ltype,line_width,Direction,sep, base_x,base_y,Aval,Angle,start_length,end_length,CData.zFzt[i].mtx);
                  end;
               end;
            100:begin
                  // V{}`f[^\
                  with mSzk[o2] do begin
                     DisplaySymbolZukei(Layer,color_flag,Color,name,start_x,start_y,rotate_angle,Scale,CData.zFzt[i].mtx);
                  end;
               end;
            end;
         end;
      end;
   end;
   lx := nil;
   ly := nil;
end;


end.
